package org.s4s.gui.views;

import com.vaadin.navigator.ViewChangeListener;
import com.vaadin.server.VaadinSession;
import com.vaadin.ui.Alignment;
import com.vaadin.ui.HorizontalLayout;
import com.vaadin.ui.Notification;
import com.vaadin.ui.Panel;
import com.vaadin.ui.UI;
import com.vaadin.ui.VerticalLayout;
import java.util.List;
import org.s4s.modell.dto.Product;
import org.s4s.modell.dto.Warenkorb;
import org.s4s.services.util.Roles;
import org.s4s.services.util.Views;

/**
 *
 * @author Holger
 */
public class WarenkorbView extends TemplateView {

    private final Warenkorb warenkorb = Warenkorb.getInstance();
    private VaadinSession session = UI.getCurrent().getSession();

    @Override
    public void enter(ViewChangeListener.ViewChangeEvent event) {
        this.setUp();
    }

    public void setUp() {
        VaadinSession session = UI.getCurrent().getSession();
        if (session.getAttribute(Roles.CURRENTUSER) == null) {
            UI.getCurrent().getNavigator().navigateTo(Views.LOGIN);
            Notification.show(null, "Einloggen, um auf den Warenkorb zuzugreifen!", Notification.Type.WARNING_MESSAGE);
        }

        final VerticalLayout contentLayout = new VerticalLayout();
        super.setUpFooterAndHeader(contentLayout);

        if (warenkorb.getAnzahl() == 0) {
            Panel panel = new Panel("Der Warenkorb ist leer!");
            this.addComponent(panel);
            this.setComponentAlignment(panel, Alignment.TOP_LEFT);
        } else {
            HorizontalLayout horizontalLayout = new HorizontalLayout();
            Panel pAnzahl = new Panel("In Ihrem Warenkorb sind momentan: " + warenkorb.getAnzahl() + " Artikel!");
            horizontalLayout.addComponent(pAnzahl);
            horizontalLayout.setComponentAlignment(pAnzahl, Alignment.TOP_LEFT);

            Panel pSum = new Panel("Gesamtwert im Warenkorb beträgt: " + warenkorb.sum());
            horizontalLayout.addComponent(pSum);
            horizontalLayout.setComponentAlignment(pSum, Alignment.TOP_RIGHT);

            this.addComponent(horizontalLayout);

            List<Product> list = warenkorb.inhalt();
            list.forEach((p) -> {
                HorizontalLayout layout = new HorizontalLayout();
                layout.addComponent(new Panel(p.getName() + ", " + p.getDescription() + ", " + p.getPrice()));
                this.addComponent(layout);
            });
        }
    }
}
